# M(login_sw) module to login to surgeweb, designed to support:
#	- Logging in to surgeweb without exlicitly entering login info and pressing submit
#   - Provide login functionality for surgeweb standlone login page and app mode login page
#   - Supports dom based and document write based html insertion
#   - Extensibile to be used with arbitrary div html anchor and to use with arbitrary html
#   - Options: modal or not, receive focus or not, draggable or not
# This just needs 
# Author: M Weehuizen - September 2007

||define||dat_file||modules/~x_login_sw.js||

var _login_DefaultObj;

function LoginSurgeweb(callback){
	// public interface:
	this.init=init;
	this.showDialog=showDialog;
	this.login=login;
	this.destroy=destroy;
	this.getSid=getSid;

#	this.docwriteHtml=docwriteHtml;
#	this.domwriteHtml=domwriteHtml;
#	this.focus=focus;
#	this.setAction=setAction;
			
	//private vars and fns
	var sid="", username, password;
	var base, anchor_id='login_pane';
	var _customAction;
	var _method="DOM", _modal=null, _drag=false, _focus=true;
	
	// these could (and probably should) be part of a common library instead
	var http, req_id = 0, response = {};
	
	_login_DefaultObj=this;
	if (callback) _customAction=callback;
	dbg("LOGIN","fns constructor LoginSurgeweb");	

	// actual fns	
	function init(fn,method,modal,drag,focus,http){
		dbg("LOGIN","fns LoginSurgeweb init");	
		if (fn) _customAction = fn;
		if (method) _method = method;
		if (modal) _modal = document.getElementById("modal");
		if (drag) _drag = drag;
		if (focus) _focus = focus;
	}	

	function showDialog(){
		if (_method=='DOM'){
			var el = domwriteHtml();
		}else{
			dbg('docwrite method not supported yet');
			return;
		}
		if (_drag) Drag.init(el);
		if (_focus) focus();
		if (_modal) _modal.style.zIndex=10;
	}

	function login(user,password){
		dbg("LOGIN","fns LoginSurgeweb init");	
	    if (http==undefined){	
			dbg("LOGIN","creating http request object");	
	    	http=createRequestObject();
	    }
	    if(user==undefined){
	    	user=document.getElementById('username').value;
	    	password=document.getElementById('password').value;
	    }
	    
	    var req="cmd=login,show&username="+user+"&password="+password+"&page=||dat_file||&show=||dat_file||&efile=||dat_file||";
		sndReq(req,function(){
				if(http.readyState != 4) return ;
				actionLogin(http.responseText);
			});
	}	

	function actionLogin(txt){
		eval(txt);		
		var new_sid = response['sid'];
		var result = response['result'];
		var el=document.getElementById('login_result');
		if (el) el.innerHTML=result+'<br>';
		if (new_sid>0){
			sid=new_sid;
			dbg("LOGIN",'login successful new sid='+sid);
		}else{
			dbg("LOGIN",'login failed');		
		}
		if (_customAction)
			_customAction(new_sid>0, sid, result);
	}

	function moduleHtml(){
		return (
			'<span id="login_result"></span>' +
			'Username:<input type="text" id="username" value=""><br>' +
			'Password:<input type="password" id="password" value=""><br>'+
			'<div id="custom"></div><br>'+
			'<input type="button" onclick="_login_doLogin();" value="Login">');
	}

	function docwriteHtml(){
		doc.write('<div id="'+anchor_id+'">');
		doc.write(moduleHtml());
		doc.write('</div>');
	}

	function domwriteHtml(other_fields){
		dbg("fns domwriteHtml");

		var s = document.getElementById(anchor_id);
		if (!s){
			s = document.createElement('div');
			s.id=anchor_id;
			document.body.appendChild(s);
		}
		s.innerHTML=moduleHtml();
		s.style.display="block";
		base=s;
		return s;
	}
	
	function destroy(){
		el=document.getElementById(anchor_id);
		if (el)
			 el.parentNode.removeChild(el);
		if (_modal) 
			_modal.style.zIndex=-10;
	}

	function focus(){
		dbg("attempting to set focus to username");
		document.getElementById('username').focus();
	}

	function setAction(fn){
		_customAction = fn;	
	}

	function getSid(){
		return sid;
	}
	
	// utility fns, could (and probably should) be part of a common library instead
	// but leave for now allowing M(login_sw) to be used standalone
	function sndReq(action,callback)
	{
		dbg("LOGIN","fns sndReq in LoginSurgeweb");
		req_id++;
		response={};
		var request = cgibase+action+"&id="+req_id+"-"+(new Date()).getTime();
		dbg("LOGIN","sending request ["+req_id+"] "+request);
		http.open('get', request);
		http.onreadystatechange = callback;
		http.send(null);
	}
	function createRequestObject() {
		dbg('fns createRequestObject');
		var ro;
		var browser = navigator.appName;
		if(browser == "Microsoft Internet Explorer"){
			ro = new ActiveXObject("Microsoft.XMLHTTP");
		}else{
			ro = new XMLHttpRequest();
		}
		return ro;
	}
}

# this contruct is still a bit yuck...
function _login_doLogin(){
	dbg("doing default login (could be overidden)");
	_login_DefaultObj.login();
}
